<template>
  <!-- section:custom_content -->
  <div>
    <v-card>
      <v-toolbar 
        color="secondary" 
        dark>
        <v-icon>business</v-icon>
        <v-toolbar-title 
          style="width: 150px" 
          class="ml-0 pl-3">
          <span class="hidden-sm-and-down">Development</span>
        </v-toolbar-title>

        <v-spacer/>


        <v-btn
        	color="primary"
        	@click="getTemp"
        	round
        >Temp</v-btn> 

        <v-btn
        	color="primary"
        	@click="startAutoTemp"
        	round
        >M155 ON</v-btn> 

        <v-btn
        	color="primary"
        	@click="stopAutoTemp"
        	round
        >M155 OFF</v-btn> 

        <v-btn
        	color="error"
        	@click="abortTask"
        	round
        >Abort</v-btn> 

        <v-btn
        	@click="sendMacro"
        	round
        >Macro</v-btn> 
        <v-btn
        	@click="hardReset"
        	round
        >Reset</v-btn>
      </v-toolbar>
    </v-card>
  </div>
  <!-- endsection:custom_content -->

</template>

<script>
// section:custom_imports
// endsection:custom_imports
    
import {bus} from '@js/bus'

export default {

	components: {
		// section:custom_components
		// endsection:custom_components
	},
        

	data() {
		// section:custom_before_data
		// endsection:custom_before_data
		return {
			// section:custom_data
			// endsection:custom_data
		}
	},

	computed: {
		// section:custom_computed
		// endsection:custom_computed
	},

	methods: {
		// section:custom_methods
		sendMacro() {
			this.$wamp.call("gcode.macro.run", ["print.abort"])
				.then(result => {
					console.log('gcode.macro.run:', result)
				})
				.catch(error => {
					console.error('gcode.macro.run:', error)
				})
		},

		hardReset() {
			this.$wamp.call("controller.reset")
				.then(result => {
					console.log('reset:', result)
				})
				.catch(error => {
					console.error('reset:', error)
				})
		},

		abortTask() {
			this.$wamp.call('task.abort')
				.then(result => {
					console.log('task.abort:', result)
					bus.$emit('show-popup', {message: 'Aborting task', color: 'success'})	
				})
				.catch(error => {
					//console.error('file.info:', error)
					bus.$emit('show-popup', {message: 'Task abort failed', color: 'error'})
				})
		},

		startAutoTemp() {
			this.$wamp.call('gcode.send', [], {
				gcode: 'M155 S2'
			})
				.then(result => {
					console.log('autotemp:', result)
				})
				.catch(error => {
					console.error('autotemp:', error)
				})
		},

		stopAutoTemp() {
			this.$wamp.call('gcode.send', [], {
				gcode: 'M155 SS'
			})
				.then(result => {
					console.log('autotemp:', result)
				})
				.catch(error => {
					console.error('autotemp:', error)
				})
		},

		getTemp() {
			this.$wamp.call('gcode.send', [], {
				gcode: 'M105'/*,
				use_regex: true,
				reply: 'ok.*'*/
			})
				.then(result => {
					console.log('temp:', result.kwargs)
				})
				.catch(error => {
					console.error('temp:', error)
				})
		}
		// endsection:custom_methods
	},
        

	// section:custom_extras
	// endsection:custom_extras
}

</script>